import java.util.Calendar;


public abstract class Character extends Element{
	protected int attackDamage;
	protected int attackDistance;
	protected long reloadTime;
	protected long lastAttack;
	protected int speed;
	
	public void moveX(int x){
		if (this.isAlive()){
			this.setX(x + this.getX());
			int oldstate = this.getState();
			int newstate;
			if (x == 0)
				newstate = 0;
			else if (x > 0){
				if (oldstate == 1)
					newstate = 2;
				else
					newstate = 1;
			}
			else {
				if (oldstate == 3)
					newstate = 4;
				else
					newstate = 3;
			}

			this.setState(newstate);
		}
	}
	
	public void inflictDamage(int d){
		this.setHp(this.getHp() - d < 0 ? 0 : this.getHp() - d);
		if (this.isDead())
			this.setState(9);
	}
	
	public void attack(Character c){
		if (getDistance(c,this) < this.getAttackDistance() && this.readyToAttack()){
			if (!(this instanceof Chtulhu))
				this.setState(5);
			c.inflictDamage(this.getAttackDamage());
			this.setLastAttack(Calendar.getInstance().getTimeInMillis());
		}
		else if (!(this instanceof Chtulhu))
			this.setState(0);
	}
	
	public boolean readyToAttack(){
		if (this.isDead())
			return false;
		long delay = Calendar.getInstance().getTimeInMillis() - this.getLastAttack();
		return delay > this.getReloadTime();
	}
	
	/// GETTERS
	
	public int getAttackDamage(){
		return this.attackDamage;
	}
	
	public int getAttackDistance(){
		return this.attackDistance;
	}
	
	public long getReloadTime(){
		return this.reloadTime;
	}
	
	public long getLastAttack(){
		return this.lastAttack;
	}
	
	public int getSpeed(){
		return this.speed;
	}
	
	/// SETTERS
	
	public void setAttackDamage(int d){
		this.attackDamage = d;
	}
	
	public void setAttackDistance(int d){
		this.attackDistance = d;
	}
	
	public void setReloadTime(long t){
		this.reloadTime = t;
	}
	
	public void setLastAttack(long t){
		this.lastAttack = t;
	}
	
	public void setSpeed(int s){
		this.speed = s;
	}
}
