
public class Chtulhu extends Character {
	private int level = 0;
	private int kills = 0;
	private double growFactor = 1;
	
	public Chtulhu(int x, int y){
		this.setX(x);
		this.setY(y);
		this.setHp(500);
		this.setAttackDamage(1);
		this.setAttackDistance(60);
		this.setSize(40);
		this.setSpeed(4);
		this.setReloadTime(10);
	}
	
	public int getLevel(){
		return level;
	}
	
	public double getGrowFactor(){
		return this.growFactor;
	}
	
	public void setLevel(int n){
		level = n;
	}
	
	public void levelUp(){
		this.kills++;
		if (kills == 20){
			Game.setMessage("LEVEL UP !");
			this.setLevel(1);
			this.growFactor = 1;
		}
		else
			this.grow(1.1);
	}
	
	public void grow(double d){
		
		if (this.kills < 27){
			this.growFactor *= d;
			this.setSize((int)(this.getSize() * d));
			this.setSpeed((int)(this.getSpeed() + 1));
			this.setAttackDistance((int)(this.getAttackDistance()*d));
		}
		this.setHp(this.getHp() + 100);
		
	}
	
	public void attack(){ // only used by Chtulhu
		Marine m_array[] = Game.getMarineArray();
		Tank t_array[] = Game.getTankArray();
		
		// animation of the attacker
		if (this.getState() == 0)
			this.setState(5);
		else if (this.getState() < 3)
			this.setState(6);
		else
			this.setState(7);
		
		// do some damage
		for (Marine m : m_array){
			if (m == null)
				break;
			if (m.isDead())
				continue;
			this.attack(m);
			if (m.isDead()){
				Game.addToScore(50);
				this.levelUp();
			}
		}
		for (Tank t : t_array){
			if (t == null)
				break;
			if (t.isDead())
				continue;
			this.attack(t);
			if (t.isDead()){
				Game.addToScore(200);
				this.levelUp();
			}
		}
	}
}
